#!/usr/bin/env python
# coding: utf-8

# In[23]:


import json
import numpy as np
import os
import random
import time
import torch
import torch.nn as nn
import torch.optim as optim
import torch.nn.functional as F
import sys
from collections import OrderedDict
from dataset_loader_FSC147 import CountingDataset, Normalize, ResizeExampleImage, ResizeImage, ToTensor,CropImage
from model import weights_normal_init,CountRegressor,Resnet50FPN
from os.path import basename, exists, join, splitext
import math
from torch.utils.data import DataLoader
from torchvision import transforms
from utilsGAN import  format_for_plotting,denormalize,visualizeOutputQuery,standardize_and_clip,getGaussianFromDot
from utilsA import extract_featuresWithFeat as extract_features
from utilsA import FeatureCovariance
from networksCycleGAN import define_G, define_D
import copy
import torchvision
from torch.utils.tensorboard import SummaryWriter
from random import randint
from utilsGAN import getGaussianFromDotA,visualizeOutputQuery,closest_dist,apply_gaussian_mask
from utilsDemo import pad_to_size
from utilsA import get_Mask 
import shutil
from utilsA import visualizeExemplar

torch.backends.cudnn.benchmark = True
# In[24]:


os.environ["CUDA_DEVICE_ORDER"]="PCI_BUS_ID"
os.environ["CUDA_VISIBLE_DEVICES"]="4,5"

"""
data downloaded from https://github.com/cvlab-stonybrook/LearningToCountEverything

"""
base_dir = "./FSC_NewDataOnly" # Dataset Name
# In[4]:
dataset_dir = join(base_dir, "dataset.json")
json_annotation = "./FSC_NewDataOnly/json_annotationCombined_384_VarV2_updated1.json"
images_dir = join(base_dir, "images_384_VarV2")
density_map_dir = join(base_dir, "gt_density_map_adaptive_384_VarV2")
src_dot_dir = './FSC_NewDataOnly/dots_original'


if not exists('save'): os.makedirs('save')
if not exists('logs'): os.makedirs('logs')


RANDOM_SEED = 600
MAX_EPOCHS = 1500
BATCH_SIZE = 14
CROP_SIZE = 384
NUM_EXAMPLES = 3
EXAMPLE_TYPE = "box"
LEARNING_RATE = 1e-5
MAX_HW = 1504
weightMap = 1e-14
#DATA_SPLIT = class_exclusive_data_split
MAPS = ['map3','map4'] # '0','1','2','3' are 4, 8, 16, 32 times smaller respectively
Scales = [0.9, 1.1]
PreTrained = False
MODEL_NAME_PREFIX = "CVN_decov_runXX"
outdir = './Results/logs/' + MODEL_NAME_PREFIX
if not exists(outdir): os.makedirs(outdir)
wpixel = 1e-5    
weightG = 1e-5
weightD= 1e-5 
wCountReal = 1.
wCountFake = 10.
num_workers = 12
DISP_STEP = 200

import shutil
disp_step = 500
train_epoch_loss = 0
train_mae = 0
train_rmse = 0
wPixel = 1e-5
wDiversity = 1e-3
wFeatureMatching = 1e-8
wCountGAN = 1e2
nstylelayers = 8
wRealCount = 1e3
weightSparsity = 1e6
wConsistency = .01
wCenter = 1e2
wGen = 1e-2
wGenCount = 1e2
wDis = 1e-2
wDisCount = 1e2
input_nc = 4
input_nc_noise = 128
output_nc = 3
output_nc_mask = 1
ngf = 64
ndf = 64
LEARNING_RATE = 1e-5
LEARNING_RATE2 = 1e-5




# In[25]:





resnet50_conv = Resnet50FPN()
resnet50_conv = nn.DataParallel(resnet50_conv)
resnet50_conv.cuda()
resnet50_conv.eval()


regressor = CountRegressor(6,pool='mean')

regressor.cuda()

weights_normal_init(regressor, dev=0.001)
regressor = nn.DataParallel(regressor)
optimizer = optim.Adam(regressor.parameters(), lr = LEARNING_RATE)
generator = define_G(input_nc, output_nc, ngf,'resnet_9blocks',norm='batch',style=True,input_nc_noise=input_nc_noise,nlayers=nstylelayers).cuda()

generator = nn.DataParallel(generator)

generator.train()

optimizer_G = optim.Adam(generator.parameters(), lr = LEARNING_RATE2)

regressor.train()
resnet50_conv.train()
# In[40]:


loss = nn.MSELoss().cuda()
criterion_GAN = torch.nn.MSELoss().cuda()
criterion_pixelwise = torch.nn.L1Loss().cuda()


# In[ ]:


all_fname = './FSC_NewDataOnly/Image_LabelsV1.txt'
train_fname = './FSC_NewDataOnly/Train_Classes.txt'
val_fname = './FSC_NewDataOnly/Val_Classes.txt'
test_fname = './FSC_NewDataOnly/Test_Classes.txt'
gray_fname = './FSC_NewDataOnly/GrayImages.txt'
not_three = './FSC_NewDataOnly/NotThreeBb.txt'
all_fname = './FSC_NewDataOnly/Image_LabelsV1.txt'
train_fname = './FSC_NewDataOnly/Train_Classes.txt'
val_fname = './FSC_NewDataOnly/Val_Classes.txt'
test_fname = './FSC_NewDataOnly/Test_Classes.txt'
gray_fname = './FSC_NewDataOnly/GrayImages.txt'
not_three = './FSC_NewDataOnly/NotThreeBb.txt'
lines_gray = [line.rstrip('\n') for line in open(gray_fname)]
lines_train = [line.rstrip('\n') for line in open(train_fname)]
lines_all = [line.rstrip('\n') for line in open(all_fname)]
lines_val = [line.rstrip('\n') for line in open(val_fname)]
lines_test = [line.rstrip('\n') for line in open(test_fname)]
train_classes = list()
val_classes = list()
test_classes  = list()
train_images = list()
test_images = list()
val_images = list()
for x in lines_train:
    x = x.split('\t')[0]
    train_classes.append(x)
for x in lines_val:
    x = x.split('\t')[0]
    val_classes.append(x)
for x in lines_test:
    x = x.split('\t')[0]
    test_classes.append(x)
for x in lines_all:
    x = x.split("\t")
    if x[1] in train_classes and x[0] not in lines_gray:
        train_images.append(x[0])
    elif x[1] in val_classes and x[0] not in lines_gray:
        val_images.append(x[0])
    elif x[1] in test_classes and x[0] not in lines_gray:
        test_images.append(x[0])
print(len(train_images),len(val_images),len(test_images))
z = 0
for x in test_images:
    if x in train_images or x in val_images:
        z += 1
print(z)


# ### Dataset

# In[15]:


with open(json_annotation) as f: annotations = json.load(f)
    
#with open(DATA_SPLIT) as f: DATA_SPLIT = json.load(f)
DATA_SPLIT = dict()
DATA_SPLIT["train"] = train_images
DATA_SPLIT["val"] = val_images
DATA_SPLIT["test"] = test_images


# In[16]:

train_c = CountingDataset(
    data_split = DATA_SPLIT["train"],
    split_type = "train",
    annotations = annotations,
    num_examples = NUM_EXAMPLES,
    example_type = EXAMPLE_TYPE,
    do_cache = True,
    transform = transforms.Compose([
        ResizeImage(MAX_HW,crop=True,dots=True),
        ToTensor(dots=True),
        Normalize(mean=[0.485, 0.456, 0.406], std=[0.229, 0.224, 0.225],dots=True),
        CropImage(crop=True,cropSize=CROP_SIZE,dots=True)
    ]),src_dot_dir=src_dot_dir)


val_c = CountingDataset(
    data_split = DATA_SPLIT["val"],
    split_type = "val",
    annotations = annotations,
    num_examples = NUM_EXAMPLES,
    example_type = EXAMPLE_TYPE,
    do_cache = False,
    transform = transforms.Compose([
        ResizeImage(MAX_HW,crop=False),
        ToTensor(),
        Normalize(mean=[0.485, 0.456, 0.406], std=[0.229, 0.224, 0.225])
    ]))

train_dataloader = DataLoader(train_c, batch_size=BATCH_SIZE, shuffle=True,num_workers=num_workers)
val_dataloader = DataLoader(val_c, batch_size=1, shuffle=False)




resume_param = False
if resume_param:
    model_name = outdir + '/' + "{}_current.pth".format(MODEL_NAME_PREFIX)
    #torch.save(regressor.state_dict(), model_name)
    regressor.load_state_dict(torch.load(model_name))
    model_name = outdir + '/' + "Optimizer_{}_current.pth".format(MODEL_NAME_PREFIX)
    #torch.save(optimizer.state_dict(), model_name)    
    optimizer.load_state_dict(torch.load(model_name))
    model_name = outdir + '/' + "{}_current_generator.pth".format(MODEL_NAME_PREFIX)
    #torch.save(generator.state_dict(), model_name)
    generator.load_state_dict(torch.load(model_name))
    model_name = outdir + '/' + "Optimizer_{}_current_generator.pth".format(MODEL_NAME_PREFIX)    
    optimizer_G.load_state_dict(torch.load(model_name))






# In[ ]:


best_mae, best_rmse = 1e7,1e7
stats = []
step1 = 0
Zero_GT = torch.zeros(BATCH_SIZE,1,384,CROP_SIZE).cuda()
start_epoch = 0
for epoch in range(start_epoch,MAX_EPOCHS):
    
    t0 = time.time()
    
    """
    Training
    """   
    step = epoch
    regressor.train()
    resnet50_conv.eval()
    generator.train()
    #netFeat.train()
    train_epoch_loss = 0
    train_mae = 0
    train_rmse = 0
    train_gen_loss = 0
    #train_gen_count_loss = 0
    train_gen_loss_sparsity = 0
    train_genPixel_loss = 0
    train_genCount_loss = 0
    train_dis_loss = 0
    train_genfeature_matching_loss = 0
    train_dis_Count_loss = 0
    train_center_loss = 0
    train_consistency_loss = 0
    train_dis_loss_artificial = 0
    train_diversity_loss = 0
    
    Alpha = 1.0
    for _, sample_batched in enumerate(train_dataloader):
        optimizer.zero_grad()
        optimizer_G.zero_grad()
        box_sum = sample_batched['boxes'].sum(dim=-1).sum(dim=-1)
        non_zero_id = torch.nonzero(box_sum.squeeze()).squeeze().tolist()
        if isinstance(non_zero_id, int):
            non_zero_id = [non_zero_id]
        if len(non_zero_id) < BATCH_SIZE:
            for j in range(0,sample_batched['boxes'].shape[0]): # replace bounding box outside the crop with one from inside
                if sample_batched['boxes'][j].sum() == 0:
                    for key in sample_batched.keys():
                        sample_batched[key][j] = sample_batched[key][non_zero_id[0]]         
        image, boxes = sample_batched['image'].cuda(), sample_batched['boxes'].cuda()
        noise = torch.randn(image.shape[0],128).cuda()
        noise1 = torch.randn(image.shape[0],128).cuda()
        density = sample_batched['density'].cuda()
        ################   real loss   ###############################
        with torch.no_grad(): features0 = extract_features(resnet50_conv,image,boxes,MAPS,Scales,returnFeat=False)  
        features0.requires_grad = True
        output0 = regressor(features0)
        ################# Generator loss    ##################################
        X = torch.cat((image,output0.detach()),1)
        #X = torch.cat((image_paste,image),1)      
        image_fake = generator(noise,X,alpha=Alpha) 
        with torch.no_grad():image_fake1 = generator(noise1,X,alpha=Alpha) 
        #Mask0 = 1 - Mask
        features,feat_match = extract_features(resnet50_conv, image_fake,  boxes,MAPS,Scales,gradientPropagate=True,returnFeat=True,feat_key = 'map3')
        with torch.no_grad(): features1,feat_match1 = extract_features(resnet50_conv, image_fake1,  boxes,MAPS,Scales,gradientPropagate=False,returnFeat=True,feat_key = 'map3')        
        loss_pixel = wPixel * criterion_pixelwise(image_fake,image)
        outputFake = regressor(features)
        loss_real_count =  wRealCount * loss(output0, density)
        loss_GAN_Count =  wGenCount * loss(outputFake, density)
        loss_diversity = wDiversity * FeatureCovariance(feat_match,feat_match1)#DotProduct(feat_match,feat_match1)
        total_loss_GAN =   loss_GAN_Count + loss_real_count + loss_pixel + loss_diversity#+ loss_GAN_feature_matching + loss_pixel
        ####### backprop through generator and counting network
        total_loss =  (total_loss_GAN )#/(1.0 * BATCH_SIZE)
        total_loss.backward()
        optimizer_G.step()
        optimizer.step()
        ##############################  
        train_epoch_loss += loss_real_count.item()
        train_diversity_loss += loss_diversity.item()
        train_genfeature_matching_loss += loss_pixel.item()#loss_GAN_feature_matching.item()
        train_genCount_loss += loss_GAN_Count.item() 

        ##############################
        cnt_err = abs(torch.sum(output0).item() - torch.sum(density).item())
        train_mae += cnt_err
        train_rmse += cnt_err ** 2      
        step1 += 1
  
           
    """
    Validation Error
    """  
    regressor.eval()
    generator.eval()
    resnet50_conv.eval()
    #netFeat.eval()
    val_mae = 0
    val_rmse = 0
    for _, sample_batched in enumerate(val_dataloader):
        with torch.no_grad():
            imageA, boxes = sample_batched['image'].cuda(), sample_batched['boxes'].cuda()
            density0 = sample_batched['density'].cuda()
            boxes = boxes.unsqueeze(0)
            with torch.no_grad(): features0 = extract_features(resnet50_conv,imageA,boxes,MAPS,Scales)  
            with torch.no_grad():output0 = regressor(features0)
            ################# Generator loss    ##################################
            cnt_err = abs(output0.sum().item() - density0.sum().item())
            val_mae += cnt_err
            val_rmse += cnt_err ** 2
    
    """
    Stats Computation
    """
    val_mae = (val_mae / val_c.__len__())
    val_rmse = (val_rmse / val_c.__len__())**0.5
    train_epoch_loss = train_epoch_loss / len(train_dataloader)
    #train_genfeature_matching_loss = train_genfeature_matching_loss / len(train_dataloader)
    train_gen_loss = train_gen_loss / len(train_dataloader)
    train_genPixel_loss = train_genPixel_loss / len(train_dataloader)
    train_genCount_loss = train_genCount_loss / len(train_dataloader)
    #train_dis_loss = train_dis_loss / len(train_dataloader)
    train_diversity_loss = train_diversity_loss / len(train_dataloader)
    #train_dis_Count_loss = train_dis_Count_loss / len(train_dataloader)
    #train_dis_loss_artificial = train_dis_loss_artificial / len(train_dataloader)
    train_mae = (train_mae / train_c.__len__())
    train_rmse = (train_rmse / train_c.__len__())**0.5
    #train_consistency_loss = train_consistency_loss / len(train_dataloader)
    train_center_loss = train_center_loss / len(train_dataloader)  
    train_epoch_loss = 0
    train_diversity_loss = 0
    train_gen_loss = 0
    train_genPixel_loss = 0
    train_genCount_loss = 0
    train_dis_loss = 0
    train_center_loss = 0
    train_dis_loss_artificial = 0
    train_gen_loss_sparsity = 0
    train_dis_Count_loss = 0
    train_consistency_loss = 0   
    train_genfeature_matching_loss = 0
    stats.append((train_epoch_loss, train_mae, train_rmse, val_mae, val_rmse,train_gen_loss,train_genCount_loss,
                  train_dis_loss))
    stats_file = join(outdir, "stats" +  ".txt")
    #print(stats_file)
    with open(stats_file, 'w') as f:
        for s in stats:
            f.write("%s\n" % ','.join([str(x) for x in s]))    
    f.close()
    """
    Saving Best Model
    """
    if best_mae >= val_mae:
        best_mae = val_mae
        best_rmse = val_rmse
        model_name = outdir + '/' + "{}_{}.pth".format(MODEL_NAME_PREFIX, epoch+1)
        torch.save(regressor.state_dict(), model_name)
        model_name = outdir + '/' + "{}_generator_best.pth".format(MODEL_NAME_PREFIX)
        torch.save(generator.state_dict(), model_name)    
    t1 = time.time()
    model_name = outdir + '/' + "{}_current.pth".format(MODEL_NAME_PREFIX)
    torch.save(regressor.state_dict(), model_name)
    model_name = outdir + '/' + "Optimizer_{}_current.pth".format(MODEL_NAME_PREFIX)
    torch.save(optimizer.state_dict(), model_name)    
    model_name = outdir + '/' + "{}_current_generator.pth".format(MODEL_NAME_PREFIX)
    torch.save(generator.state_dict(), model_name)
    model_name = outdir + '/' + "Optimizer_{}_current_generator.pth".format(MODEL_NAME_PREFIX)
    torch.save(optimizer_G.state_dict(), model_name)    
    print("CVN run Decov 3: {} Model: {} Avg. Epoch Loss: {} Train MAE: {} Train RMSE: {} Val MAE: {} Val RMSE: {} Best Val MAE: {} Best Val RMSE: {} Time taken: {} secs".format(
              epoch+1, MODEL_NAME_PREFIX, stats[-1][0], stats[-1][1], stats[-1][2], stats[-1][3], stats[-1][4], best_mae, best_rmse, round((t1-t0))))





writer.close()







