import json
import math
import matplotlib.pyplot as plt
import numpy as np
import os
import random
import xml.etree.ElementTree as ET
import glob
from torchvision import transforms
import torch
import cv2
import copy
from math import ceil, exp, pi, sqrt
from os.path import basename, exists, join, splitext
from PIL import Image, ImageDraw
from skimage import io
from random import randint
from utilsGAN import *
from collections import OrderedDict

import numpy as np
import os
import random
import time
import torch
import torch.nn as nn
import torch.optim as optim
import torch.nn.functional as F
from os.path import basename, exists, join, splitext
import math
from torchvision import transforms

def pad_to_size(feat, desire_h, desire_w):
    """ zero-padding a four dim feature matrix: N*C*H*W so that the new Height and Width are the desired ones
        desire_h and desire_w should be largers than the current height and weight
    """

    cur_h = feat.shape[-2]
    cur_w = feat.shape[-1]

    left_pad = (desire_w - cur_w + 1) // 2
    right_pad = (desire_w - cur_w) - left_pad
    top_pad = (desire_h - cur_h + 1) // 2
    bottom_pad =(desire_h - cur_h) - top_pad

    return F.pad(feat, (left_pad, right_pad, top_pad, bottom_pad))

def extract_features(feature_model, image, Boxes,Maps,Scales,netFeat):
    #boxes = boxes.squeeze()
    N, M = image.shape[0], Boxes.shape[2]
    """
    Getting features for the image N * C * H * W
    """
    with torch.no_grad():
        Image_features = feature_model(image)
    #image_features = feature_model(image)
    #Examples_features = feature_model(
    #    examples.view(-1, examples.shape[2], examples.shape[3], examples.shape[4])
    #)
    """
    Getting features for the examples (N*M) * C * h * w
    """
    #examples_features = feature_model(
    #    examples.view(-1, examples.shape[2], examples.shape[3], examples.shape[4])
    #)
    #print(N)
    for ix in range(0,N):
        boxes = Boxes[ix].squeeze()
        cnter = 0
        Cnter1 = 0
        # = Image_featuresA[ix][
        for keys in Maps:
            image_features = Image_features[keys][ix].unsqueeze(0)
            if keys == 'map1' or keys == 'map2':
                Scaling = 4.0
            elif keys == 'map3':
                Scaling = 8.0
            elif keys == 'map4':
                Scaling =  16.0
            else:
                Scaling = 32.0
            #Cnter1 = 0
            #y1,x1,y2,x2 = math.ceil(boxes[1]/Scaling),math.ceil(boxes[2]/Scaling),math.ceil(boxes[3]/Scaling),math.ceil(boxes[4]/Scaling)
            y1,x1,y2,x2 = math.ceil(boxes[0,1]/Scaling),math.ceil(boxes[0,2]/Scaling),math.ceil(boxes[0,3]/Scaling),math.ceil(boxes[0,4]/Scaling)
            boxes1 = 1. * boxes
            X = 1 * (1 + x2 - x1)
            Y = 1 * (1 + y2 - y1)
            for j in range(0,M):
                #y11,x11,y21,x21 = math.ceil(boxes[1]/Scaling),math.ceil(boxes[2]/Scaling),math.ceil(boxes[3]/Scaling),math.ceil(boxes[4]/Scaling)
                #boxes1[1],boxes1[2],boxes1[3],boxes1[4] = boxes[2],boxes[1],boxes[4],boxes[3]        
                y11,x11,y21,x21 = math.ceil(boxes[j,1]/Scaling),math.ceil(boxes[j,2]/Scaling),math.ceil(boxes[j,3]/Scaling),math.ceil(boxes[j,4]/Scaling)
                boxes1[j,1],boxes1[j,2],boxes1[j,3],boxes1[j,4] = boxes[j,2],boxes[j,1],boxes[j,4],boxes[j,3]                
                if x21 - x11 > x2 - x1:
                    x2 = 1 * x21
                    x1 = 1 * x11
                    X = 1 * (x2 - x1) + 1
                if y21 - y11 > y2 - y1:
                    y2 = 1 * y21
                    y1 = 1* y11
                    Y = 1 * (y2 - y1) + 1
            for j in range(0,M):
                y11,x11 = math.ceil(boxes[j,1]/Scaling),math.ceil(boxes[j,2]/Scaling)
                if y11 == 0:
                    y11 = 1
                if x11 == 0:
                    x11 = 1
                if x11 + X > image_features.shape[2]:
                    x11 = image_features.shape[2] - (X + 1)
                if y11 + Y > image_features.shape[3]:
                    y11 = image_features.shape[3] - (Y + 1)               
                if j == 0:
                    examples_features = image_features[:,:,x11:x11 + X + 1, y11:y11+1+Y]
                else:
                    #print(X,Y,x11,y11)
                    feat = image_features[:,:,x11-1:x11 + X + 1, y11-1:y11+1+Y]
                    if feat.shape[2] != examples_features.shape[2] or feat.shape[3] != examples_features.shape[3]:
                        feat = F.interpolate(feat, size=(examples_features.shape[2],examples_features.shape[3]),mode='bilinear')
                    examples_features = torch.cat((examples_features,feat),dim=0)
            """
            Convolving example features over image features
            """
            h, w = examples_features.shape[2], examples_features.shape[3]
            if h == 1:
                examples_features = F.interpolate(examples_features, size=(2,examples_features.shape[3]),mode='bilinear')
                h = 2
            if w == 1:
                examples_features = F.interpolate(examples_features, size=(examples_features.shape[2],2),mode='bilinear')
                w = 2
            #print(h,w,examples_features.shape)
            examples_features.requires_grad = True
            examples_features = examples_features + netFeat(examples_features,keys)
            features =    F.conv2d(
                    F.pad(image_features, ((int(w/2)), int((w-1)/2), int(h/2), int((h-1)/2))),
                    examples_features
                )
            #print(features.shape)
            #features_avg = torch.mean(features, dim=(1), keepdim=True)    
            #features_max, _ = torch.max(features, 1, keepdim=True)
            combined = features.permute([1,0,2,3])
            h, w = examples_features.shape[2], examples_features.shape[3]
            for scale in Scales:
                    h1 = math.ceil(h * scale)
                    w1 = math.ceil(w * scale)
                    if h1 < 1:
                        h1 = 1 * h
                    if w1 < 1:
                        w1 = 1 * w
                    examples_features1 = F.interpolate(examples_features, size=(h1,w1),mode='bilinear')  
                    features1 =    F.conv2d(F.pad(image_features, ((int(w1/2)), int((w1-1)/2), int(h1/2), int((h1-1)/2))),
                    examples_features1)
                    features1 = features1.permute([1,0,2,3])
                    #features_avg1 = torch.mean(features1, dim=(1), keepdim=True)    
                    #features_max1, _ = torch.max(features1, 1, keepdim=True)
                    combined = torch.cat((combined,features1),dim=1)
                    #features_avg = torch.cat((features_avg,features_avg1),dim=1)        
            #combined = torch.cat([features_avg, features_max], dim = 1)
            #print('Combined',combined.shape)
            if cnter == 0:
                Combined = 1.0 * combined
            else:
                if Combined.shape[2] != combined.shape[2] or Combined.shape[3] != combined.shape[3]:
                    combined = F.interpolate(combined, size=(Combined.shape[2],Combined.shape[3]),mode='bilinear')
                Combined = torch.cat((Combined,combined),dim=1)
            cnter += 1
        if ix == 0:
            All_feat = 1.0 * Combined.unsqueeze(0)
            #print('Combined',Combined.shape)
        else:
            All_feat = torch.cat((All_feat,Combined.unsqueeze(0)),dim=0)
            #print('Combined',Combined.shape)
            #print('All',All_feat.shape)
    return All_feat

def extract_featuresNew(feature_model, images, boxes, feat_map_keys=['map3','map4'], exemplar_scales=[0.9, 1.1],netFeat=None):
    """
        images: NxCxHxW tensor, where N is the number images in the batch, C is the number of channels
        boxes_ix:  Nx1xMx5 tensor, where M is the number of bounding boxes_ix per images
        return: features for the exemplars of size N * M * (#scales x #maps) * h * w
    """

    N, M = images.shape[0], boxes.shape[2]
    images_features = feature_model(images)

    for ix in range(0,N):
        boxes_ix = boxes[ix].squeeze()
        Combined = None

        for keys in feat_map_keys:
            im_feats = images_features[keys][ix].unsqueeze(0)
            feat_h = im_feats.shape[2]
            feat_w = im_feats.shape[3]

            if keys == 'map1' or keys == 'map2':
                feat_map_scale = 4.0
            elif keys == 'map3':
                feat_map_scale = 8.0
            elif keys == 'map4':
                feat_map_scale = 16.0
            else:
                feat_map_scale = 32.0

            boxes_ix_s = boxes_ix/feat_map_scale

            # boxes_ix_s = torch.round(boxes_ix/feat_map_scale)
            # It is better to extend the box a bit rather than rounding
            boxes_ix_s[:, 1:3] = torch.floor(boxes_ix_s[:, 1:3])
            boxes_ix_s[:, 3:5] = torch.ceil(boxes_ix_s[:, 3:5])

            boxes_ix_s[:, 3:5] = boxes_ix_s[:, 3:5] + 1 # make the end index exclusive for convinient of processing

            # make sure it doesn't go out of bound
            boxes_ix_s[:, 1:3] = torch.clamp_min(boxes_ix_s[:, 1:3], 0)
            boxes_ix_s[:, 3] = torch.clamp_max(boxes_ix_s[:, 3], feat_w)
            boxes_ix_s[:, 4] = torch.clamp_max(boxes_ix_s[:, 4], feat_h)

            combined = None
            for j in range(0,M): # for each provided examplar bounding box
                x1, y1, x2, y2 = int(boxes_ix_s[j, 1]), int(boxes_ix_s[j, 2]), int(boxes_ix_s[j, 3]), int(boxes_ix_s[j, 4])
                
                feat = im_feats[:,:,y1:y2, x1:x2]
                #feat.requires_grad = True
                h, w = feat.shape[2], feat.shape[3]
                feat = feat + netFeat(feat,keys)
                # Get convolution feature map. Need to check if we should do correlation instead!!!
                conv_map = F.conv2d(F.pad(im_feats, ((int(w/2)), int((w-1)/2), int(h/2), int((h-1)/2))), feat)
                conv_map = conv_map.permute([1,0,2,3])

                for scale in exemplar_scales: # for each scale
                    h1 = math.ceil(h * scale)
                    w1 = math.ceil(w * scale)

                    scale_feat = F.interpolate(feat, size=(h1,w1),mode='bilinear')
                    scale_conv_map = F.conv2d(F.pad(im_feats, ((int(w1/2)), int((w1-1)/2), int(h1/2), int((h1-1)/2))), scale_feat)
                    scale_conv_map = scale_conv_map.permute([1,0,2,3])
                    conv_map = torch.cat((conv_map,scale_conv_map),dim=1)

                if combined is None:
                    combined = conv_map
                else:
                    combined = torch.cat((combined, conv_map),dim=0)

            if Combined is None:
                Combined = combined
            else:
                if Combined.shape[2] != combined.shape[2] or Combined.shape[3] != combined.shape[3]:
                    combined = F.interpolate(combined, size=(Combined.shape[2],Combined.shape[3]),mode='bilinear')
                Combined = torch.cat((Combined,combined),dim=1)

        if ix == 0:
            All_feat = Combined.unsqueeze(0)
        else:
            All_feat = torch.cat((All_feat,Combined.unsqueeze(0)),dim=0)

    return All_feat



def pad_to_size(feat, desire_h, desire_w):
    """ zero-padding a four dim feature matrix: N*C*H*W so that the new Height and Width are the desired ones
        desire_h and desire_w should be largers than the current height and weight
    """

    cur_h = feat.shape[-2]
    cur_w = feat.shape[-1]

    left_pad = (desire_w - cur_w + 1) // 2
    right_pad = (desire_w - cur_w) - left_pad
    top_pad = (desire_h - cur_h + 1) // 2
    bottom_pad =(desire_h - cur_h) - top_pad

    return F.pad(feat, (left_pad, right_pad, top_pad, bottom_pad))


def jitterDot_add(src_dot,to_be_jittered):
    tgt_dot = 1.0 * src_dot
    H,W = tgt_dot.shape
    #dot = torch.from_numpy(dot_map)
    #dot.shape
    #src_dot = copy.deepcopy(dot)
    cnt = src_dot.sum()
    new_cnt =  int(cnt * (to_be_jittered/100.))
    if new_cnt == 0:
        new_cnt += 1
    for i in range(0,new_cnt):
        check = 0
        while(check == 0):
            x = randint(0,W-1)
            y = randint(0,H-1)
            if tgt_dot[y,x] == 0:
                check += 1
                tgt_dot[y,x] = 1.
    return tgt_dot

def closest_dist(p, points):
    d = [math.sqrt((p[0] - q[0])**2 + (p[1] - q[1])**2) for q in points if p != q]
    i = np.argmin(d)
    
    return (points[i], d[i])
def gauss2D(shape, sigma=1):
    """
    2D gaussian mask - should give the same result as MATLAB's
    fspecial('gaussian',[shape],[sigma])
    """
    m,n = [(ss-1.)/2. for ss in shape]
    y,x = np.ogrid[-m:m+1,-n:n+1]
    h = np.exp( -(x*x + y*y) / (2.*sigma*sigma) )
    h[ h < np.finfo(h.dtype).eps*h.max() ] = 0
    sumh = h.sum()
    if sumh != 0: h /= sumh
    return h

def apply_gaussian_mask(A, r1, c1, r2, c2, sd):

    M = gauss2D((r2-r1+1, c2-c1+1), sigma = sd)
    
    # Copied from: https://stackoverflow.com/questions/53124061/how-can-i-add-a-small-matrix-into-a-big-one-with-numpy
    A[r1:r2+1, c1:c2+1] += M
    
    return A

def getGaussianFromDotA(tgt_dot,src_dot,src_density):
    indices_y,indices_x = np.nonzero(src_dot)
    points = list()
    for i in range(0,len(indices_x)):
        points.append([indices_y[i],indices_x[i]])
    #print(indices)
    d = [closest_dist(p, points)[1] for p in points]
    mean_r = np.mean(d) / 2.0

    r_x = max(15, min(60, int(round(mean_r))))
    r_y = max(15, min(60, int(round(mean_r))))
    #print(r_x,r_y)
    H,W = src_dot.shape
    density_map = 1.0 * src_density

    assert r_x == r_y, "Code does not support generation of ellipse"

    sd = round(r_x / 4.0)
    indices_y,indices_x = np.nonzero(abs(src_dot-tgt_dot))
    points = list()
    for i in range(0,len(indices_x)):
        points.append([indices_y[i],indices_x[i]])
    for point in points:
        x, y = point

        r1 = int(round(max(0, y - r_y)))
        c1 = int(round(max(0, x - r_x)))

        r2 = int(round(min(H-1, y + r_y)))
        c2 = int(round(min(W-1, x + r_x)))

        density_map = apply_gaussian_mask(density_map, r1, c1, r2, c2, sd)
    return density_map


def getGaussianFromDot(src_dot):
    indices_x,indices_y = np.nonzero(src_dot)
    points = list()
    for i in range(0,len(indices_x)):
        points.append([indices_y[i],indices_x[i]])
    #print(indices)
    d = [closest_dist(p, points)[1] for p in points]
    mean_r = np.mean(d) / 2.0

    r_x = max(15, min(60, int(round(mean_r))))
    r_y = max(15, min(60, int(round(mean_r))))
    #print(r_x,r_y)
    H,W = src_dot.shape
    density_map = np.zeros((H,W))

    assert r_x == r_y, "Code does not support generation of ellipse"

    sd = round(r_x / 4.0)

    for point in points:
        x, y = point

        r1 = int(round(max(0, y - r_y)))
        c1 = int(round(max(0, x - r_x)))

        r2 = int(round(min(H-1, y + r_y)))
        c2 = int(round(min(W-1, x + r_x)))

        density_map = apply_gaussian_mask(density_map, r1, c1, r2, c2, sd)
    return density_map
Normalize = transforms.Compose([transforms.ToTensor(),
    transforms.Normalize(mean=[0.485, 0.456, 0.406], std=[0.229, 0.224, 0.225])])

def visualizeOutputGAN(input_, input2,output,output2,output3, guided=False, use_gpu=False,
              figsize=(20, 6), cmap='viridis', alpha=.5,
              return_output=False):

    # Setup subplots
    img1 = format_for_plotting(denormalize(input_))
    img2 = format_for_plotting(denormalize(input2))
    #img1 = AddBoxes(img1,boxes,Query=None)
    subplots = [
        # (title, [(image1, cmap, alpha), (image2, cmap, alpha)])
        ('Src image ',
         [(img1, None, None)]),
        ('Generated image' ,
         [(img2,
          None,
          None)]),
        ('Synthetic GT cnt ' + str(int(output.sum().item())),
         [(format_for_plotting(standardize_and_clip(output)),
          None,
          None)]) ,
        ('Real pred cnt' + str(int(output2.sum().item())),
         [(format_for_plotting(standardize_and_clip(output2)),
          None,
          None)]),
        ('Fake pred cnt' + str(int(output3.sum().item())),
         [(format_for_plotting(standardize_and_clip(output3)),
          None,
          None)])
    ]

    fig = plt.figure(figsize=figsize)

    for i, (title, images) in enumerate(subplots):
        ax = fig.add_subplot(1, len(subplots), i + 1)
        ax.set_axis_off()
        ax.set_title(title)

        for image, cmap, alpha in images:
            ax.imshow(image, cmap=cmap, alpha=alpha)

    if return_output:
        return gradients, max_gradients

def visualizeOutputQuery(input_, gt,output, guided=False, use_gpu=False,
              figsize=(20, 6), cmap='viridis', alpha=.5,
              return_output=False):

    # Setup subplots
    img1 = format_for_plotting(denormalize(input_))
    #img1 = AddBoxes(img1,boxes,Query=None)
    subplots = [
        # (title, [(image1, cmap, alpha), (image2, cmap, alpha)])
        ('Input image ',
         [(img1, None, None)]),
        ('Original dot ' ,
         [(format_for_plotting(standardize_and_clip(gt)),
          None,
          None)]),
        ('Transformed dot ' ,
         [(format_for_plotting(standardize_and_clip(output)),
          None,
          None)])    
    ]

    fig = plt.figure(figsize=figsize)

    for i, (title, images) in enumerate(subplots):
        ax = fig.add_subplot(1, len(subplots), i + 1)
        ax.set_axis_off()
        ax.set_title(title)

        for image, cmap, alpha in images:
            ax.imshow(image, cmap=cmap, alpha=alpha)

    if return_output:
        return gradients, max_gradients
    
import matplotlib.pyplot as plt
def denormalize(tensor):
    """Reverses the normalisation on a tensor.
    Performs a reverse operation on a tensor, so the pixel value range is
    between 0 and 1. Useful for when plotting a tensor into an image.
    Normalisation: (image - mean) / std
    Denormalisation: image * std + mean
    Args:
        tensor (torch.Tensor, dtype=torch.float32): Normalized image tensor
    Shape:
        Input: :math:`(N, C, H, W)`
        Output: :math:`(N, C, H, W)` (same shape as input)
    Return:
        torch.Tensor (torch.float32): Demornalised image tensor with pixel
            values between [0, 1]
    Note:
        Symbols used to describe dimensions:
            - N: number of images in a batch
            - C: number of channels
            - H: height of the image
            - W: width of the image
    """

    means = [0.485, 0.456, 0.406]
    stds = [0.229, 0.224, 0.225]

    denormalized = tensor.clone()

    for channel, mean, std in zip(denormalized[0], means, stds):
        channel.mul_(std).add_(mean)

    return denormalized


def standardize_and_clip(tensor, min_value=0.0, max_value=1.0,
                         saturation=0.1, brightness=0.0):

    """Standardizes and clips input tensor.
    Standardizes the input tensor (mean = 0.0, std = 1.0). The color saturation
    and brightness are adjusted, before tensor values are clipped to min/max
    (default: 0.0/1.0).
    Args:
        tensor (torch.Tensor):
        min_value (float, optional, default=0.0)
        max_value (float, optional, default=1.0)
        saturation (float, optional, default=0.1)
        brightness (float, optional, default=0.5)
    Shape:
        Input: :math:`(C, H, W)`
        Output: Same as the input
    Return:
        torch.Tensor (torch.float32): Normalised tensor with values between
            [min_value, max_value]
    """

    tensor = tensor.detach().cpu()

    mean = tensor.mean()
    std = tensor.std()

    if std == 0:
        std += 1e-7

    standardized = tensor#.sub(mean).div(std).mul(saturation)
    clipped = standardized#.add(brightness).clamp(min_value, max_value)

    return clipped

def standardize_and_clip0(tensor, min_value=0.0, max_value=1.0,
                         saturation=0.1, brightness=0.5):

    """Standardizes and clips input tensor.
    Standardizes the input tensor (mean = 0.0, std = 1.0). The color saturation
    and brightness are adjusted, before tensor values are clipped to min/max
    (default: 0.0/1.0).
    Args:
        tensor (torch.Tensor):
        min_value (float, optional, default=0.0)
        max_value (float, optional, default=1.0)
        saturation (float, optional, default=0.1)
        brightness (float, optional, default=0.5)
    Shape:
        Input: :math:`(C, H, W)`
        Output: Same as the input
    Return:
        torch.Tensor (torch.float32): Normalised tensor with values between
            [min_value, max_value]
    """

    tensor = tensor.detach().cpu()

    mean = tensor.mean()
    std = tensor.std()

    if std == 0:
        std += 1e-7

    standardized = tensor.sub(mean).div(std).mul(saturation)
    clipped = standardized.add(brightness).clamp(min_value, max_value)

    return clipped

def format_for_plotting(tensor):
    """Formats the shape of tensor for plotting.
    Tensors typically have a shape of :math:`(N, C, H, W)` or :math:`(C, H, W)`
    which is not suitable for plotting as images. This function formats an
    input tensor :math:`(H, W, C)` for RGB and :math:`(H, W)` for mono-channel
    data.
    Args:
        tensor (torch.Tensor, torch.float32): Image tensor
    Shape:
        Input: :math:`(N, C, H, W)` or :math:`(C, H, W)`
        Output: :math:`(H, W, C)` or :math:`(H, W)`, respectively
    Return:
        torch.Tensor (torch.float32): Formatted image tensor (detached)
    Note:
        Symbols used to describe dimensions:
            - N: number of images in a batch
            - C: number of channels
            - H: height of the image
            - W: width of the image
    """

    has_batch_dimension = len(tensor.shape) == 4
    formatted = tensor.clone()

    if has_batch_dimension:
        formatted = tensor.squeeze(0)

    if formatted.shape[0] == 1:
        return formatted.squeeze(0).detach()
    else:
        return formatted.permute(1, 2, 0).detach()
    
def AddBoxes(img0,boxes,Query=None):
    #boxes = boxes.squeeze()
    #Query = Query.squeeze()
    #img1 = 1.0 * img0
    img = 1.0 * img0
    if boxes.shape[1] > 1:
        boxes = boxes.squeeze()
        for i in range(0,boxes.shape[0]):
            x1,y1,x2,y2 = int(boxes[i,2].item()),int(boxes[i,1].item()),int(boxes[i,4].item()),int(boxes[i,3].item())
            img[x1:x2,y1-2:y1+2,1] = 1.
            img[x1-2:x1+2,y1:y2,1] = 1.
            img[x1:x2,y2-2:y2+2,1] = 1.
            img[x2-2:x2+2,y1:y2,1] = 1.
    else:
        boxes = boxes.squeeze()
        #for i in range(0,boxes.shape[0]):
        x1,y1,x2,y2 = int(boxes[2].item()),int(boxes[1].item()),int(boxes[4].item()),int(boxes[3].item())
        img[x1:x2,y1-2:y1+2,1] = 1.
        img[x1-2:x1+2,y1:y2,1] = 1.
        img[x1:x2,y2-2:y2+2,1] = 1.
        img[x2-2:x2+2,y1:y2,1] = 1. 
    if Query is not None:
        if Query.shape[1] > 1:
            Query = Query.squeeze()
            for i in range(0,Query.shape[0]):
                x1,y1,x2,y2 = int(Query[i,2].item()),int(Query[i,1].item()),int(Query[i,4].item()),int(Query[i,3].item())
                img[x1:x2,y1-2:y1+2,0] = 1.
                img[x1-2:x1+2,y1:y2,0] = 1.
                img[x1:x2,y2-2:y2+2,0] = 1.
                img[x2-2:x2+2,y1:y2,0] = 1.
        else:
            Query = Query.squeeze()
            x1,y1,x2,y2 = int(Query[2].item()),int(Query[1].item()),int(Query[4].item()),int(Query[3].item())
            img[x1:x2,y1-2:y1+2,0] = 1.
            img[x1-2:x1+2,y1:y2,0] = 1.
            img[x1:x2,y2-2:y2+2,0] = 1.
            img[x2-2:x2+2,y1:y2,0] = 1.        
    return img
